package com.fr.plugin.xxx.zojj.sso.conf;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.stable.StringUtils;


/**
 * @author xxx
 * @since 2021/12/04
 */
@Visualization(category = "域认证单点登录配置")
public class SsoConfig extends DefaultConfiguration {

    private static volatile SsoConfig config = null;

    public static SsoConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(SsoConfig.class);
        }
        return config;
    }

    @Identifier(value = "debugSwitch", name = "插件调试开关", description = "日志调试模式", status = Status.SHOW)
    private Conf<Boolean> debugSwitch = Holders.simple(true);

    public Boolean getDebugSwitch() {
        return debugSwitch.get();
    }

    public void setDebugSwitch(Boolean debugSwitch) {
        this.debugSwitch.set(debugSwitch);
    }

    @Identifier(value = "ssoUrl", name = "sso服务器登录地址", description = "sso服务器", status = Status.SHOW)
    private Conf<String> ssoUrl = Holders.simple(StringUtils.EMPTY);

    public String getSsoUrl() {
        return this.ssoUrl.get();
    }

    public void setSsoUrl(String url) {
        this.ssoUrl.set(url);
    }

    @Identifier(value = "validUrl", name = "验证jwt地址", description = "验证jwt地址", status = Status.SHOW)
    private Conf<String> validUrl = Holders.simple(StringUtils.EMPTY);

    public String getValidUrl() {
        return validUrl.get();
    }

    public void setValidUrl(String key) {
        validUrl.set(key);
    }

    @Identifier(value = "logout", name = "logout", description = "登出地址", status = Status.SHOW)
    private Conf<String> logout = Holders.simple(StringUtils.EMPTY);

    public String getLogout() {
        return logout.get();
    }

    public void setLogout(String key) {
        logout.set(key);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        SsoConfig cloned = (SsoConfig) super.clone();
        cloned.debugSwitch = (Conf<Boolean>) debugSwitch.clone();
        cloned.logout = (Conf<String>) logout.clone();
        cloned.ssoUrl = (Conf<String>) ssoUrl.clone();
        cloned.validUrl = (Conf<String>) validUrl.clone();
        return cloned;
    }


    public boolean isAccept() {
        return StringUtils.isNotBlank(getSsoUrl()) && StringUtils.isNotBlank(getValidUrl());
    }
}
